// Created with MonoDevelop
//
//    Copyright (C) 2024 Hiperscan GmbH Dresden, Germany
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

using System;
using System.Reflection;
using System.Collections.Generic;

using Hiperscan.Unix;
using Hiperscan.Spectroscopy;

namespace Hiperscan.Spectroscopy.Processing
{
    public partial class SpectrumProcessor
    {
        public override Spectrum ProcessingBlack
        {
            get
            {
                if (this.processing_black == null)
                    this.UpdateBlackReference();
                return this.processing_black;
            }
        }

        public override Spectrum ProcessingWhite
        {
            get
            {
                if (this.processing_white == null)
                    this.UpdateWhiteReference();
                return this.processing_white;
            }
        }

        public override Spectrum CorrectedOxideOfSample
        {
            get
            {
                if (this.corrected_oxide_of_sample == null)
                    this.UpdateOxidOfSample();
                return this.corrected_oxide_of_sample;
            }
        }

        public override Spectrum CorrectedOxideOfReferences
        {
            get
            {
                if (this.corrected_oxide_of_reference == null)
                    this.UpdateOxidOfSample();
                return this.corrected_oxide_of_reference;
            }
        }

        public override Spectrum ProcessingSampleInsertWhite
        {
            get
            {
                if (this.processing_sample_insert_white == null)
                    this.UpdateSampleInsertWhiteReference();
                return this.processing_sample_insert_white;
            }
        }

        public override Spectrum ProcessingTransflectanceInsert
        {
            get
            {
                if (this.processing_transflectance_insert == null)
                    this.UpdateTransflactenceInsertReference();
                return this.processing_transflectance_insert;
            }
        }

        public override DataSet ProcessingBackground
        {
            get
            {
                if (this.processing_external_background == null)
                    this.UpdateProcessingBackground();

                return this.processing_external_background;
            }
        }

        public override DataSet ProcessingDark
        {
            get
            {
                if (this.processing_external_dark == null)
                    this.UpdateProcessingBlack();

                return this.processing_external_dark;
            }
        }
    }
}
